'FFSubmenu=Dokumentation
'FFName=Bilderinfo nach CSV

' ***********************************************************************
' ImageInfo_To_CSV.vbs (Script fr FixFoto)
'
' Funktion:     Schreibt Dateinamen mit ausgewhlten Zusatzinformationen
'				in eine neue CSV-Datei (Trennzeichen ;).
'
' Version 1.07 vom 11.07.2009 Lschroutine hinzugefgt und KB entsprechend ergnzt
' Version 1.06 vom 16.06.2009 Formatierung der Brennweitenwerte gendert
' Version 1.05				  bersprungen
' Version 1.04 vom 13.06.2009 Brennweite wahlweise im Original und/oder KB-Wert
' Version 1.03 vom 17.03.2009 Erweiterung um Kommentar und Geodaten
' Version 1.02 vom 21.11.2007 Erluterungen hinzugefgt
'							  Abfrage, ob CSV-Datei existiert vorverlegt
'							  Stand.-Button fr Bildfilter hinzugefgt
' Version 1.01 vom 29.10.2007 "Standard" umbenannt in "Alle Daten"
' Version 1.00 vom 25.10.2007 Beta basierend auf ImageInfo_To_Excel
'  
' Copyright (C) Harald Maeckler, Dsseldorf

'** Start Kurzbeschreibung *******************************************
' ImageInfo to CSV / Version 1.07
' ====================
'
' Das Skript bertrgt die ausgewhlten Daten in eine CSV-Datei. Diese kann an-
' schlieend mit einem Tabellenprogramm, z.B. Excel oder OpenOffice Calc, geff-
' net werden. Als Trennzeichen wird das Semikolon verwendet.
'
' Einstellungen
' ----------------
' - ausgewhlte Bilder
' - alle Bilder gem Bildfilter (s.unten)
' - alle Dateien
' Bei 'alle Bilder' und 'alle Dateien' knnen auf Wunsch die Unterverzeich-
' nisse einbezogen werden.
'
' CSV-Datei
' ------------
' Das Ablageverzeichnis kann ber 'ndern' frei gewhlt werden.
' Der Dateiname ist beliebig, muss aber die Ergnzung .CSV haben.
'
' Bildfilter
' ----------
' - Der Filter kann beliebig editiert werden.
' - Mit (S)tandard wird wieder der Filter 'BMP-JP2-JPG-PNG-TIF' hergestellt.
'
' Allgemein
' ------------
' 'x' oben rechts bricht das Skript ab.
' '?' zeigt die vorliegende Erluterung an.
' 'Alle Daten' whlt alle Daten aus.
' 'OK' startet die Ausgabe der Daten.
'
'
'		Weitere Informationen zur Handhabung von
'		CSV-Dateien sind im Skriptordner als PDF-
'		Datei unter dem Namen 'Skript ImageInfo'
'		zu finden."
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D
' eine Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft,
' ob das zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem
' Lschen angeboten, davon eine Sicherheitskopie an einem beliebigen Speicherort ab-
' zulegen. Danach werden nacheinander die Skriptdatei, die in der Registry dazuge-
' hrenden Daten und eventuelle Zusatzdateien gelscht. Abschlieend wird die 
' FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript
' mit allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Copyright Harald Maeckler
'** Ende Kurzbeschreibung ********************************************

Option Explicit

'Standardfilter fr 'Alle Bilder'
Const BildKenn = "BMP-JP2-JPG-PNG-TIF"

Const debuging = False

Dim n				'Zhlervariable
Dim m				'Zhlervariable
Dim objFolder	 	'Ordner
Dim objsubfolder	'Unterordner
Dim imagecount		'BildZhler
Dim objFile	 		'Dateien
Dim Dimension		'Tiefe des Datenarrys
Dim Gesamtanzahl	'Lnge des Datenarrays
Dim FileAnzahl	 	'Dateizhler
Dim SubAnzahl		'Ordnerzhler
Dim Tiefe			'Tiefe der Ordnerstruktur
Dim msg				'Message
Dim	DatGross		'Summe der Dateigren
Dim Array()			'Wertetabelle
Dim AeDatum			'nderungsdatum
Dim AuDatum			'Aufnahmedatum
Dim Zeile	 	 	'Zeile
Dim Spalte			'Spalte
Dim strExt	 		'Extension einer Datei
Dim Pfad			'Pfadangabe eines Ordners
Dim Anzahl			'Dateianzahl eines Ordners
Dim KursivListe		'Liste mit Ordnernamen
Dim Element			'Element der Kursivliste
Dim KameraModell	'Kamera-Modell aus Exif
Dim EndSpalte		'letzte Spalte

Dim ZusText			'Zusammenfassung
Dim Info1			'Info temporr eins
Dim Info2			'Info temporr zwei
Dim Pos				'StringPosition
Dim Antwort			'Antwort
Dim Abbruch			'Abbruch
Dim BFilter			'Bildfilter
Dim TabZeile		'Tabellenzeile
Dim BezZeile		'Bezeichnungszeile

Dim Breite			'Breite in Pixel
Dim Hoehe			'Hhe in Pixel

Dim ZText1			'ZwischenText
Dim ZText2			'ZwischenText
Dim Text			'CSV-Text
Dim CSVpfad			'CSV-Pfad
Dim CSVdatei		'CSV-Datei
Dim TxtName			'Name der CSV-Datei mit Pfad
Dim objAusgabe		'Objekt CSV-Ausgabe

'Exif-Konstanten
Const Kamera = "Model"					'Kameraname (Exif)
Const AufnDatum	= "DateTimeOriginal" 	'Aufnahmedatum (Exif)
Const Blende = "FNumber"				'Blende
Const Zeit = "ExposureTime"				'Belichtungszeit
Const Korrektur = "ExposureBiasValue"	'Belichtungskorrektur
Const Brennweite = "FocalLength"		'Brennweite (OG + KB)
Const ISO = "ISOSpeedRatings"			'Empfindlichkeit
Const Blitz = "Flash"					'Blitz (codiert)

dim Taste,SkriptKill,TempFile
dim DokuWert,AllgWert,ExifWert,FilterWert
dim Doku(3),Allg(2),Exif(10),AllgSp(2),ExifSp(10)
dim BW_Org,BW_KB

const SkriptName = "ImageInfo_To_CSV.vbs"					'Skriptname
Dim Kurzbeschreibung, KBvorhanden, LaengeMax				'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim objFS,WshShell											'Objekte

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'******************* VB-Script **************************************

call main
'---------------------------------------------------------------------
Sub main

Set objFolder = objFS.GetFolder(FF_GetImagePath())			'aktiver Ordner

	on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
		imagecount = FF_GetImageCount
 		if Err.Number = 500 then
			msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
			exit sub
		end if
	on error goto 0

	If objFolder Is Nothing Then							'kein Ordner bekannt 
		MsgBox "Kein Ordner ausgewhlt." & Newline & "Die Dokumentation wird abgebrochen!",vbCritical,"Abbruch"
		exit sub
	end if
		
'**  Dialogbehandlung ***********************************************
call Dialogaufruf
	'Registry lesen
	DokuWert = FF_GetProfile("FF_Doku-CSV", "DokuWert")
call WertBestimmung
call WerteEintrag
call Auswerten
call RegistrySchreiben

	FF_CloseDialog("Dateien-Doku")
	
if SkriptKill then		'ggf. Skript komplett entfernen
	call KillSkript
	exit sub
end if

'** Ende Dialogbehandlung ********************************************

if Abbruch then
	'msgbox "Das Skript wird abgebrochen!",vbCritical,"Abbruch"
	exit sub
end if

'** Abfrage ob Bilder ausgewhlt wurden
if Doku(0) = "1" then		'ausgewhlte Bilder
	imagecount = FF_GetImageCount
	if debuging then msgbox "Bilderzahl " & imagecount
	if imagecount = 0 then
		Antwort = msgbox("Es wurde kein(e) Bild(er) ausgewhlt." & vbCr & _
		"Es werden alle Bilder dokumentiert (ohne Uvz.).",vbOkCancel,"Abfrage")
		if Antwort = vbCancel then 
			Abbruch = True
		else
			Doku(0) = "0"	'ausgew.Bilder
			Doku(1) = "1"	'alle Bilder
		end if
	end if
end if

if Abbruch then
	msgbox "Das Skript wird abgebrochen!",vbCritical,"Abbruch"
	exit sub
end if

'** Arraygre bestimmen
call ArrayGroesse
Redim Array(Gesamtanzahl + 1, Dimension + 2)

'** Eintrag der Kopfzeilen
'Definitionen
if Doku(0) = "1" then
	msg = "Ausgewhlte Bilder"
elseif Doku(1) = "1" then
	msg = "Alle Bilder gefiltert mit " & BFilter
elseif Doku(2) = "1" then
	msg = "Alle Dateien"
end if

if Doku(3) = "1" then msg = msg & " incl. Inhalt von Unterverzeichnissen"
ZText1 = msg

call Ueberschrift

'** Array-Eintrag
TabZeile = 1
FileAnzahl = 0
if Doku(0) = "1" then										'ausgew. Bilder
	For m=0 to imagecount - 1
		set objFile = objFS.GetFile(FF_GetImageName(m))
		TabZeile = TabZeile + 1
		call Tabellenerstellung
	Next
	
	TabZeile = TabZeile + 1
	call DateigroessenFormat
	ZText2 = objFolder.name & " - " & Fileanzahl &_
				" Dateien / " &	DatGross					'Ordnername
	Array(BezZeile+1,0) = objFolder.name
else
	ShowSubfolder ObjFolder,0
	call DateigroessenFormat
end if

'** Eintrge der berschriften in die Textvariable
Text = Text & objFolder.Path & vbNewLine
Text = Text & DatGross & " gesamt / " & SubAnzahl - 1 & " Unterordner / insgesamt " &_
		FormatNumber(FileAnzahl,0) & " Dateien" & vbNewLine
Text = Text & ZText2 & vbNewLine
Text = Text & ZText1 & vbNewLine & vbNewLine

'** Arraybertragung in die Textvariable
	For n = 0 to ubound(Array,1)
		Text = Text & ";"
		For m = 0 to ubound(Array,2)
			Text = Text & Array(n,m) & ";"
		next
		Text = Text & vbNewLine
	next

'** Ermittelte Dateiinfo in eine Textdatei bertragen
Set objAusgabe = objfs.CreateTextFile(TxtName)
objAusgabe.WriteLine text
objAusgabe.Close
msgbox "Die Datei-Infos wurden in die Textdatei" & vbNewLine & _
		TxtName & vbNewLine & "bertragen.",,"Meldung"
		
End sub
'********************************************************************
'Dialogbehandlung
'********************************************************************
sub Dialogaufruf()
'** Start Dialog Dateien-Doku **
FF_AddDialog "Dateien-Doku",165,224
FF_AddControl "Dateien-Doku","FixFoto - Doku in CSV-Datei","STATIC",47,0,67,11
FF_AddControl "Dateien-Doku","Einstellungen","GROUP",7,11,70,167
FF_AddControl "Dateien-Doku","Dokumentation","GROUP",10,20,63,56
FF_AddControl "Dateien-Doku","ausgBld","BOOL",15,30,8,8
FF_SetControlStyle "Dateien-Doku","ausgBld",16384
FF_AddControl "Dateien-Doku","ausgew. Bilder","STATIC",30,28,38,11
FF_AddControl "Dateien-Doku","alleBld","BOOL",15,40,8,8
FF_SetControlStyle "Dateien-Doku","alleBld",16384
FF_AddControl "Dateien-Doku","alle Bilder","STATIC",30,39,38,11
FF_AddControl "Dateien-Doku","alleDat","BOOL",15,50,8,8
FF_SetControlStyle "Dateien-Doku","alleDat",16384
FF_AddControl "Dateien-Doku","alle Dateien","STATIC",30,48,38,11
FF_AddControl "Dateien-Doku"," ","GROUP",26,36,44,36
FF_AddControl "Dateien-Doku","mUV","BOOL",30,60,8,8
FF_AddControl "Dateien-Doku","mit Uvz.","STATIC",47,59,21,11
FF_AddControl "Dateien-Doku","CSV-Datei","GROUP",10,83,63,93
FF_AddControl "Dateien-Doku","Verzeichnis:","STATIC",13,91,33,11
FF_AddControl "Dateien-Doku","Ordner","EDIT",13,101,57,28
FF_SetControlStyle "Dateien-Doku","Ordner",2048
FF_AddControl "Dateien-Doku","ndern","BUTTON",25,133,33,11
FF_AddControl "Dateien-Doku","Dateiname:","STATIC",13,145,33,11
FF_AddControl "Dateien-Doku","CSV_Datei","EDIT",13,155,57,10
FF_SetControlStyle "Dateien-Doku","CSV_Datei",1
FF_AddControl "Dateien-Doku","Daten","GROUP",82,11,77,167
FF_AddControl "Dateien-Doku","Allgemein","GROUP",86,20,70,38
FF_AddControl "Dateien-Doku","DTyp","BOOL",90,29,8,8
FF_AddControl "Dateien-Doku","Dateityp","STATIC",105,27,33,11
FF_AddControl "Dateien-Doku","DGro","BOOL",90,38,8,8
FF_AddControl "Dateien-Doku","Dateigre (Byte)","STATIC",105,36,45,11
FF_AddControl "Dateien-Doku","DAeD","BOOL",90,47,8,8
FF_AddControl "Dateien-Doku","nderungsdatum","STATIC",105,45,45,11
FF_AddControl "Dateien-Doku","Exif (nur bei Bilder)","GROUP",85,59,71,117
FF_AddControl "Dateien-Doku","EKam","BOOL",90,68,8,8
FF_AddControl "Dateien-Doku","Kameratyp","STATIC",105,66,47,11
FF_AddControl "Dateien-Doku","EAuD","BOOL",90,77,8,8
FF_AddControl "Dateien-Doku","Aufnahmedatum","STATIC",105,75,47,11
FF_AddControl "Dateien-Doku","EGrP","BOOL",90,86,8,8
FF_AddControl "Dateien-Doku","Gre (Pixel)","STATIC",105,84,47,11
FF_AddControl "Dateien-Doku","EBld","BOOL",90,95,8,8
FF_AddControl "Dateien-Doku","Blende","STATIC",105,93,47,11
FF_AddControl "Dateien-Doku","EBeZ","BOOL",90,104,8,8
FF_AddControl "Dateien-Doku","Belichtungszeit","STATIC",105,102,47,11
FF_AddControl "Dateien-Doku","EKorr","BOOL",90,113,8,8
FF_AddControl "Dateien-Doku","Bel.-Korrektur (EV)","STATIC",105,111,47,11
FF_AddControl "Dateien-Doku","EBrw","BOOL",90,122,8,8
FF_SetControlStyle "Dateien-Doku","EBrw",16384
FF_AddControl "Dateien-Doku","Brennweite","STATIC",105,120,47,11
FF_AddControl "Dateien-Doku","BW_Org","BOOL",98,130,8,8
FF_SetControlStyle "Dateien-Doku","BW_Org",16384
FF_AddControl "Dateien-Doku","Original","STATIC",106,129,21,10
FF_AddControl "Dateien-Doku","BW_KB","BOOL",128,130,8,8
FF_SetControlStyle "Dateien-Doku","BW_KB",16384
FF_AddControl "Dateien-Doku","Kleinb.","STATIC",137,129,17,10
FF_AddControl "Dateien-Doku","EBlz","BOOL",90,139,8,8
FF_AddControl "Dateien-Doku","Blitz (Ein/Aus)","STATIC",105,138,47,11
FF_AddControl "Dateien-Doku","EISO","BOOL",90,148,8,8
FF_AddControl "Dateien-Doku","Empfindl. (ISO)","STATIC",105,147,47,11
FF_AddControl "Dateien-Doku","EKomm","BOOL",90,157,8,8
FF_AddControl "Dateien-Doku","Kommentar","STATIC",105,156,47,11
FF_AddControl "Dateien-Doku","EGeo","BOOL",90,166,8,8
FF_AddControl "Dateien-Doku","Geodaten","STATIC",105,164,48,11
FF_AddControl "Dateien-Doku","Bildfilter","GROUP",7,179,152,26
FF_AddControl "Dateien-Doku","Filter","SLEDIT",10,189,131,11
FF_AddControl "Dateien-Doku","S","BUTTON",145,189,10,11
FF_AddControl "Dateien-Doku","?","BUTTON",11,209,11,11
FF_AddControl "Dateien-Doku","Alle Daten","BUTTON",53,209,33,11
FF_AddControl "Dateien-Doku","OK","BUTTON",118,209,38,11
FF_AddControl "Dateien-Doku","&d","BUTTON",37,211,1,1
'** End Dialog Dateien-Doku **

end sub
'********************************************************************
Sub WertBestimmung
'Auswahlwerte
if FF_GetProfile("FF_Doku-CSV", "Version") <> ">=1.04" then 
	DokuWert = "0/1/0/0"
	AllgWert = "1/1/1"
	ExifWert = "1/1/1/1/1/1/1/1/1/1/1"
	BFilter = BildKenn
	CSVpfad = "C:"
	CSVdatei = "Image_Info.CSV"
	BW_Org = "1"
	BW_KB = "1"
else
	AllgWert = FF_GetProfile("FF_Doku-CSV", "AllgWert")
	ExifWert = FF_GetProfile("FF_Doku-CSV", "ExifWert")
	BFilter = FF_GetProfile("FF_Doku-CSV", "FilterWert")
	CSVpfad = FF_GetProfile("FF_Doku-CSV", "Ordner")
	CSVdatei = FF_GetProfile("FF_Doku-CSV", "Datei")
	BW_Org = FF_GetProfile("FF_Doku-CSV", "BW_Org")
	BW_KB = FF_GetProfile("FF_Doku-CSV", "BW_KB")
end if
end sub
'********************************************************************
sub WerteEintrag()
'Werte eintragen
DokuWert = split(DokuWert,"/",-1)
FF_SetControl "Dateien-Doku","ausgBld",DokuWert(0)
FF_SetControl "Dateien-Doku","alleBld",DokuWert(1)
FF_SetControl "Dateien-Doku","alleDat",DokuWert(2)
FF_SetControl "Dateien-Doku","mUV",DokuWert(3)

FF_SetControl "Dateien-Doku","Ordner",CSVpfad
FF_SetControl "Dateien-Doku","CSV_Datei",CSVdatei

AllgWert = split(AllgWert,"/",-1)
FF_SetControl "Dateien-Doku","DTyp",AllgWert(0)
FF_SetControl "Dateien-Doku","DGro",AllgWert(1)
FF_SetControl "Dateien-Doku","DAeD",AllgWert(2)

ExifWert = split(ExifWert,"/",-1)
FF_SetControl "Dateien-Doku","EKam",ExifWert(0)
FF_SetControl "Dateien-Doku","EAuD",ExifWert(1)
FF_SetControl "Dateien-Doku","EGrP",ExifWert(2)
FF_SetControl "Dateien-Doku","EBld",ExifWert(3)
FF_SetControl "Dateien-Doku","EBeZ",ExifWert(4)
FF_SetControl "Dateien-Doku","EKorr",ExifWert(5)
FF_SetControl "Dateien-Doku","EBrw",ExifWert(6)
FF_SetControl "Dateien-Doku","EBlz",ExifWert(7)
FF_SetControl "Dateien-Doku","EISO",ExifWert(8)
FF_SetControl "Dateien-Doku","EKomm",ExifWert(9)
FF_SetControl "Dateien-Doku","EGeo",ExifWert(10)

FF_SetControl "Dateien-Doku","BW_Org",BW_Org
FF_SetControl "Dateien-Doku","BW_KB",BW_KB
FF_SetControl "Dateien-Doku","Filter",BFilter
end sub
'********************************************************************
sub Auswerten()
'Auswahl anzeigen und auswerten

FF_ActivateControl "Dateien-Doku","&d"

do
	Taste = FF_ShowDialog("Dateien-Doku")
	if Taste =  "&d" then
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	elseif Taste = "ausgBld" then 
		FF_SetControl "Dateien-Doku","ausgBld","1"
		FF_SetControl "Dateien-Doku","alleBld","0"
		FF_SetControl "Dateien-Doku","alleDat","0"
		FF_SetControl "Dateien-Doku","mUV","0"
	elseif Taste = "alleBld" then
		FF_SetControl "Dateien-Doku","ausgBld","0"
		FF_SetControl "Dateien-Doku","alleBld","1"
		FF_SetControl "Dateien-Doku","alleDat","0"
	elseif Taste = "alleDat" then
		FF_SetControl "Dateien-Doku","ausgBld","0"
		FF_SetControl "Dateien-Doku","alleBld","0"
		FF_SetControl "Dateien-Doku","alleDat","1"
	elseif Taste = "BW_Org" then
		FF_SetControl "Dateien-Doku","EBrw","1"
		if FF_GetControl ("Dateien-Doku","BW_KB") = "0" then
			FF_SetControl "Dateien-Doku","BW_Org","1"
		end if
	elseif Taste = "BW_KB" then
		FF_SetControl "Dateien-Doku","EBrw","1"
		if FF_GetControl ("Dateien-Doku","BW_Org") = "0" then
			FF_SetControl "Dateien-Doku","BW_KB","1"
		end if
	elseif Taste = "ndern" then
		CSVpfad = FF_EnterPath(true, "Ordnerauswahl")
		FF_SetControl "Dateien-Doku","Ordner",CSVpfad
	elseif Taste = "S" then
		BFilter = FF_GetControl("Dateien-Doku","Filter")
		if BFilter <> BildKenn then
		Antwort = msgbox("Soll der Bildfilter wieder seinen Standard " & vbNewLine & _
						 Bildkenn & " erhalten?",vbYesNo,"Abfrage")
		if Antwort = vbYes then
			BFilter = BildKenn
			FF_SetControl "Dateien-Doku","Filter",BFilter
		end if
		end if
	end if
	
	if Taste = "?" then
		Abbruch = false
		if not KBvorhanden then	call KurzbeschreibungLesen
		if KBvorhanden then
			call KurzbeschreibungAnzeigen
		else
			msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
		end if
	elseif Taste = "OK" then
	
		'CSV-Dateiname prfen
		CSVdatei = FF_GetControl("Dateien-Doku","CSV_Datei")
		if len(CSVdatei) > 0 then
			Pos = instrrev(CSVdatei,".")
			if Pos > 0 then
				if ucase(mid(CSVdatei,Pos)) = "CSV" then
					'OK
				else
					CSVdatei = left(CSVdatei,Pos) & "CSV"
				end if
			else
				CSVdatei = CSVdatei & ".CSV"
			end if
			FF_SetControl "Dateien-Doku","CSV_Datei",CSVdatei
			
			'CSV-Datei auf Existenz prfen
			TxtName = CSVpfad & "\" & CSVdatei
			If objFS.FileExists(TxtName) Then
				Antwort = msgbox("Die Infodatei" & vbNewLine & TxtName & vbNewLine & _
				"existiert bereits." & vbNewLine & _
				"Soll sie berschrieben werden?",vbYesNo,"Sicherheitsabfrage")
				if Antwort = vbYes then	exit do
			else
				exit do
			end if
		else
			msgbox "Es muss ein Dateiname eingegeben werden!"
		end if
	elseif Taste = "CANCEL" then
		Abbruch = True
		exit do
	elseif Taste = "Alle Daten" then
		AllgWert = "1/1/1"
		ExifWert = "1/1/1/1/1/1/1/1/1/1/1"
AllgWert = split(AllgWert,"/",-1)
FF_SetControl "Dateien-Doku","DTyp",AllgWert(0)
FF_SetControl "Dateien-Doku","DGro",AllgWert(1)
FF_SetControl "Dateien-Doku","DAeD",AllgWert(2)

ExifWert = split(ExifWert,"/",-1)
FF_SetControl "Dateien-Doku","EKam",ExifWert(0)
FF_SetControl "Dateien-Doku","EAuD",ExifWert(1)
FF_SetControl "Dateien-Doku","EGrP",ExifWert(2)
FF_SetControl "Dateien-Doku","EBld",ExifWert(3)
FF_SetControl "Dateien-Doku","EBeZ",ExifWert(4)
FF_SetControl "Dateien-Doku","EKorr",ExifWert(5)
FF_SetControl "Dateien-Doku","EBrw",ExifWert(6)
FF_SetControl "Dateien-Doku","EBlz",ExifWert(7)
FF_SetControl "Dateien-Doku","EISO",ExifWert(8)
FF_SetControl "Dateien-Doku","EKomm",ExifWert(9)
FF_SetControl "Dateien-Doku","EGeo",ExifWert(10)
	end if
loop
end sub
'********************************************************************
sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\FF_Doku-CSV
'Auswahl in Registry sichern
Doku(0) = FF_GetControl("Dateien-Doku","ausgBld")
Doku(1) = FF_GetControl("Dateien-Doku","alleBld")
Doku(2) = FF_GetControl("Dateien-Doku","alleDat")
Doku(3) = FF_GetControl("Dateien-Doku","mUV")
FF_WriteProfile "FF_Doku-CSV","DokuWert",Doku(0) & "/" & Doku(1) & _
									 "/" & Doku(2) & "/" & Doku(3)

CSVpfad = FF_GetControl("Dateien-Doku","Ordner")
FF_WriteProfile "FF_Doku-CSV","Ordner",CSVpfad

CSVdatei = FF_GetControl("Dateien-Doku","CSV_Datei")
FF_WriteProfile "FF_Doku-CSV","Datei",CSVdatei

Allg(0) = FF_GetControl("Dateien-Doku","DTyp")
Allg(1) = FF_GetControl("Dateien-Doku","DGro")
Allg(2) = FF_GetControl("Dateien-Doku","DAeD")
FF_WriteProfile "FF_Doku-CSV","AllgWert",Allg(0) & "/" & Allg(1) & _
													 "/" & Allg(2)

Exif(0) = FF_GetControl("Dateien-Doku","EKam")
Exif(1) = FF_GetControl("Dateien-Doku","EAuD")
Exif(2) = FF_GetControl("Dateien-Doku","EGrP")
Exif(3) = FF_GetControl("Dateien-Doku","EBld")
Exif(4) = FF_GetControl("Dateien-Doku","EBeZ")
Exif(5) = FF_GetControl("Dateien-Doku","EKorr")
Exif(6) = FF_GetControl("Dateien-Doku","EBrw")
Exif(7) = FF_GetControl("Dateien-Doku","EBlz")
Exif(8) = FF_GetControl("Dateien-Doku","EISO")
Exif(9) = FF_GetControl("Dateien-Doku","EKomm")
Exif(10) = FF_GetControl("Dateien-Doku","EGeo")

FF_WriteProfile "FF_Doku-CSV","ExifWert",Exif(0) & "/" & Exif(1) & "/" & Exif(2) & "/" & Exif(3) & _
					 "/" & Exif(4) & "/" & Exif(5) & "/" & Exif(6) & "/" & Exif(7) & "/" & Exif(8) & _
					 "/" & Exif(9) & "/" & Exif(10)

BW_Org = FF_GetControl("Dateien-Doku","BW_Org")
FF_WriteProfile "FF_Doku-CSV","BW_Org",BW_Org
BW_KB = FF_GetControl("Dateien-Doku","BW_KB")
FF_WriteProfile "FF_Doku-CSV","BW_KB",BW_KB

BFilter = FF_GetControl("Dateien-Doku","Filter")
FF_WriteProfile "FF_Doku-CSV","FilterWert",BFilter

FF_WriteProfile "FF_Doku-CSV","Version",">=1.04"

end sub
'********************************************************************
sub ArrayGroesse
'Ermittlung der Dimension
For n = 0 to 2
	if Allg(n) = "1" then Dimension = Dimension + 1
next

For n = 0 to 10
	if Exif(n) = "1" then Dimension = Dimension + 1
next
if Exif(2) = "1" then Dimension = Dimension + 1	'Bildgre BxH und Pixel

'Ermittlung der Gesamtanzahl (Ordner und Dateien)
if Doku(0) = "1" then 
	Gesamtanzahl = imagecount
		SubAnzahl = 1
		FileAnzahl = imagecount
elseif Doku(3) = "1" then
	ZaehlerSub (objFolder)
	Gesamtanzahl = SubAnzahl - 1 + FileAnzahl
elseif Doku(1) = "1" or Doku(2) = "1" then
	Gesamtanzahl = objFolder.files.count
		SubAnzahl = 1
else
	msgbox "Keine Doku ausgewhlt -> Abbruch"
	FF_ErrorBreak "Abbruch"
end if
end sub
'********************************************************************
Sub ZaehlerSub(ByVal myfolder)
'Zhlen der Ordner, Unterordner und Dateien

SubAnzahl = SubAnzahl + 1						'Anzahl Unterordner
FileAnzahl = FileAnzahl + myfolder.files.count	'Anzahl Dateien

For Each objsubfolder In myfolder.subfolders
     ZaehlerSub (objsubfolder)
Next

end sub
'********************************************************************
Sub Ueberschrift
'berschrift ins Array eintragen
n = 0
Array(0,0) = "ON" : n = n + 1
Array(0,1) = "Dateiname" : n = n + 1

'Allgemeine Daten
if Allg(0) = "1" then Array(0,n) = "Ext." : AllgSp(0) = n : n = n + 1
if Allg(1) = "1" then Array(0,n) = "Byte" : AllgSp(1) = n : n = n + 1
if Allg(2) = "1" then Array(0,n) = "nder.-Datum" : AllgSp(2) = n : n = n + 1

'Exif-Daten
if Exif(0) = "1" then Array(0,n) = "Kamera" : ExifSp(0) = n : n = n + 1
if Exif(1) = "1" then Array(0,n) = "Aufn.-Datum" : ExifSp(1) = n : n = n + 1
if Exif(2) = "1" then 
					  Array(0,n) = "BxH [Px]" : ExifSp(2) = n : n = n + 1
					  Array(0,n) = "Pixel" : 					n = n + 1
end if
if Exif(3) = "1" then Array(0,n) = "Bld" : ExifSp(3) = n : n = n + 1
if Exif(4) = "1" then Array(0,n) = "Zeit" : ExifSp(4) = n : n = n + 1
if Exif(5) = "1" then Array(0,n) = "EV" : ExifSp(5) = n : n = n + 1
if Exif(6) = "1" then Array(0,n) = "Brennweite" : ExifSp(6) = n : n = n + 1
if Exif(7) = "1" then Array(0,n) = "Blitz" : ExifSp(7) = n : n = n + 1
if Exif(8) = "1" then Array(0,n) = "ISO" : ExifSp(8) = n : n = n + 1
if Exif(9) = "1" then Array(0,n) = "Kommentar" : ExifSp(9) = n : n = n + 1
if Exif(10) = "1" then Array(0,n) = "Geodaten" : ExifSp(10) = n : n = n + 1

EndSpalte = n+2

end sub
'********************************************************************
Sub Tabellenerstellung
'Werteeintrag ins Array
Dim KommentarElemente,BoolZeile,Wert

on error resume next

n = 1
Anzahl = Anzahl + 1									'Dateianzahl im Ordner
FileAnzahl = FileAnzahl + 1							'Dateianzahl gesamt
DatGross = DatGross + objFile.Size					'Dateigren gesamt
			
'** Allgemeine Daten
					  Array(TabZeile,n) = objFile.Name : n = n + 1	'** Dateiname
strExt = objFS.GetExtensionName(objFile.Name) 						'Datei-Extension ermitteln
if Allg(0) = "1" then Array(TabZeile,n) = UCase(strExt) : n = n + 1	'** Extension
if Allg(1) = "1" then Array(TabZeile,n) = FormatNumber(objFile.Size,0,,,-2) : n = n + 1	'** Gre
if Allg(2) = "1" then
		AeDatum = objFile.DateLastModified
		If IsDate(AeDatum) then
			AeDatum = FormatDateTime(AeDatum, 2) & " " & FormatDateTime(AeDatum, 4)
		end if
					  Array(TabZeile,n) = AeDatum : n = n + 1		'** nderungsdatum
end if

'** Exif-Daten

if Ucase(strExt) = "JPG" then
	FF_LoadImage objFile											'Bild laden

				KameraModell = FF_GetExifTag(Kamera)
		if Exif(0) = "1" then Array(TabZeile,n) = KameraModell : n = n + 1		'** Kamera
		if Exif(1) = "1" then 
				AuDatum = FF_GetExifTag(AufnDatum)
				If IsDate(AuDatum) then
					AuDatum = FormatDateTime(AuDatum, 2) & " " & FormatDateTime(AuDatum, 4)
				elseif instr(AuDatum, ":") = 5 then
					AuDatum = mid(AuDatum,9,2) & "." & mid(AuDatum,6,2) & "." & left(AuDatum,4) & mid(AuDatum,11)
				end if
							  Array(TabZeile,n) = AuDatum : n = n + 1					'** Aufnahmedatum
		end if
		if Exif(2) = "1" then
				Breite = FF_GetImageWidth()
				Hoehe = FF_GetImageHeight()
							  Array(TabZeile,n) = Breite & " x " & Hoehe : n = n + 1	'** Gre in Pixel
							  Array(TabZeile,n) = FormatNumber(Breite * Hoehe,0,,,-2)	: n = n + 1
		end if
		if Exif(3) = "1" then
				Info1 = FF_GetExifTagAdvanced(Blende)
				Pos = instr(Info1,".")
				if Pos > 0 then Info1 = left(Info1,Pos-1) & "," & mid(Info1,Pos+1)
							 Array(TabZeile,n) = Info1 : n = n + 1						'** Blende
		end if 
		if Exif(4) = "1" then Array(TabZeile,n) = "'" & FF_GetExifTagAdvanced(Zeit) : n = n + 1	'** Zeit
		
		if Exif(5) = "1" then
				Info1 = FF_GetExifTag(Korrektur)
				Pos = instr(Info1,".")
				if Pos > 0 then Info1 = left(Info1,Pos-1) & "," & mid(Info1,Pos+1)
							  Array(TabZeile,n) = Info1 : n = n + 1						'** Bel.-Korrektur
		end if
		
		if Exif(6) = "1" then
			if BW_Org = 1 and BW_KB = 1 then				'Original- und KB-Brennweite
				Info1 = FF_GetExifTagAdvanced(Brennweite)
				Pos = instr(Info1,"KB:")
				if Pos = 0 then Info1 = Info1 & " (KB:-)"
			elseif BW_Org = 1 then							'nur Original-Brennweite
				Info1 = FF_GetExifTag("FocalLength")
				Pos = instr(Info1,".")
				if Pos > 0 then Info1 = left(Info1,Pos-1) & "," & mid(Info1,Pos+1)
				Info1 = round(Info1,2)
			else											'nur Kleinbild-Brennweite
				Info1 = FF_GetExifTagAdvanced(Brennweite)
				Pos = instr(Info1,"KB:")
				if Pos > 0 then 
					Info1 = mid(Info1,Pos+3)
					Pos = instr(Info1,")")
					Info1 = left(Info1,Pos-1)
					Pos = instr(Info1,".")
					if Pos > 0 then Info1 = left(Info1,Pos-1) & "," & mid(Info1,Pos+1)
					Info1 = round(Info1,2)
				else
					Info1 = "KB fehlt"
				end if
			end if
							  Array(TabZeile,n) = Info1 : n = n + 1						'** Brennweite
		end if
		
		if Exif(7) = "1" then
				Info1 = FF_GetExifTag(Blitz)
				if len(Info1) > 0 then
					Info2 = Info1 / 2 : Info2 = Info2 - Int(Info2)
					if  Info2 > 0 then Info1 = "Ein" else Info1 = "Aus"
				end if
							  Array(TabZeile,n) = Info1 : n = n + 1						'** Blitz
		end if
		if Exif(8) = "1" then
				Info1 = FF_GetExifTag(ISO)
				if len(Info1) = 0 then Info1 = "n.v."
							  Array(TabZeile,n) = Info1 : n = n + 1						'** ISO
		end if
		if Exif(9) = "1" then
				Info1 = FF_GetExifTag("UserComment")
				if len(Info1) = 0 then 
					Info1 = "n.v."
				else
					do				'Bereinigung des Anfangs
						if asc(left(Info1,1)) < 32 and len(Info1) > 1 then
							Info1 = mid(Info1,2)
						else
							exit do
						end if
					loop
					
					do				'Bereinigung des Endes
						if asc(right(Info1,1)) < 32  and len(Info1) > 1 then
							Info1 = left(Info1,len(Info1)-1)
						else
							exit do
						end if
					loop
					
						KommentarElemente = split(Info1,vbNewLine)
						BoolZeile = false
						Info1 = " "
						
							'Kommentar einzeilig
							for each Wert in KommentarElemente
								Info1 = Info1 & Wert &  " | "
								BoolZeile = true
							next
							if BoolZeile then Info1 = left(Info1,len(Info1)-2)					
				end if
					
							  Array(TabZeile,n) = Info1 : n = n + 1						'** Kommentar
		end if
		if Exif(10) = "1" then
				Info1 = FF_GetExifTag("Latitude")
				if len(Info1) = 0 then 
					Info1 = "n.v."
				else
					Info1 = Info1 & " | " & FF_GetExifTag("Longitude") & " | " & FF_GetExifTag("Altitude")
				end if
							  Array(TabZeile,n) = Info1									'** Geodaten
		end if	
end if

'Fortschrittsanzeige
FF_SetProgressText TabZeile,GesamtAnzahl,"Bitte warten"

end sub
'********************************************************************
sub DateigroessenFormat
'Dateigre formatieren auf Byte, kB bzw. MB

if DatGross < 1024 then
	DatGross = DatGross & " Byte"
elseif DatGross < 1024^2 then
	DatGross = FormatNumber(DatGross / 1024,2) & " kB"
else
	DatGross = FormatNumber(DatGross / 1024^2,2) & " MB"
end if

end sub
'********************************************************************
Sub ShowSubfolder(ByVal myfolder,ByVal Tiefe)
'Eintrag der Ordnernamen in das Array
if Tiefe <= 0 or Doku(3) = "1" then	
	Pfad = myfolder.name					'wenn kompletter Pfad gewnscht, .name durch .path ersetzen
	BezZeile = TabZeile
	msg = string(Tiefe,">") & "  " & Pfad
	TabZeile = TabZeile + 1

	'*** Ermittlung aller Dateien  des Ordners
	Anzahl = 0
	For Each objFile In myfolder.Files										'Dateien-Auflistung
		strExt = objFS.GetExtensionName(objFile.Name) 						'Datei-Extension ermitteln
		if instr(Ucase(BFilter), Ucase(strExt)) > 0 or Doku(2) = "1" then	'alle Bilder oder alle Dateien
			call Tabellenerstellung
			TabZeile = TabZeile + 1
		end if
	next
	Array(BezZeile,0) =  LTrim(msg) & " - " & Anzahl & " Dateien"
end if

	For Each objsubfolder In myfolder.subfolders
		ShowSubfolder objsubfolder, Tiefe + 1
	Next
	
End Sub
'********************************************************************
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim BreiteKB	: BreiteKB = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",BreiteKB,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,BreiteKB,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",BreiteKB/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile, ZZ

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	ZZ = ZZ + 1
	if ZZ > 1000 then msgbox "Fehler in der Kurzbeschreibung! (objFS?)" : exit sub
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad
const RegSchluessel = "\FF_Doku-CSV\"

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
TempFile = FF_GetScriptPath & "\ImageInfo_to_CSV.pdf"		'Infodatei
if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

'TempFile = FF_GetScriptPath & "\BeipackSammlung"			'Ordnerbeispiel
'if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script" & RegSchluessel
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------